﻿using System;
using UnityEngine;

namespace Power
{
    public class Power : MonoBehaviour
    {
        public static void Main()
        {
            ModAPI.Register<TimeManager>();
            ModAPI.Register<TimeStop>();



            ModAPI.RegisterPower<HealPower>("Heal Power", "Heals all life nearby.", ModAPI.LoadSprite("heal.png"));
            ModAPI.RegisterPower<PressurePower>("Pressure", "Add gravity to all life nearby.", ModAPI.LoadSprite("grav.png"), "Acid");
            ModAPI.RegisterPower<CurePower>("Cure", "Cure all zombies nearby.", ModAPI.LoadSprite("Cure.png"), "Heal Power");
            ModAPI.RegisterPower<PainPower>("Pain", "Inflicts pain to all life nearby.", ModAPI.LoadSprite("Pain.png"), "Acid");
            ModAPI.RegisterPower<SuffocationPower>("Suffocate", "Suffocates all life nearby.", ModAPI.LoadSprite("suf.png"), "Acid");
            ModAPI.RegisterPower<DetachPower>("Detach", " ", ModAPI.LoadSprite("decay.png"), "Acid");
            ModAPI.RegisterPower<AcidPower>("Acid", "Inflicts acid damage to all life nearby", ModAPI.LoadSprite("acid.png"));
            ModAPI.RegisterPower<Crush>("Crush Power", " ", ModAPI.LoadSprite("Crushj.png"), "Acid");
            ModAPI.RegisterPower<HeadExp>("Head Explosion", " ", ModAPI.LoadSprite("HeadBang.png"), "Acid");
            ModAPI.RegisterPower<Rot>("Rot", " ", ModAPI.LoadSprite("zombie.png"), "Acid");
            ModAPI.RegisterPower<BoneHeal>("Bone Heal", "Heals bones", ModAPI.LoadSprite("BoneHeal.png"), "Heal Power");
            ModAPI.RegisterPower<BloodOff>("Vampire", "Sucks blood", ModAPI.LoadSprite("Vampire.png"), "Acid");
            ModAPI.RegisterPower<Electro>("Charge", " ", ModAPI.LoadSprite("electro.png"), "Acid");
            ModAPI.RegisterPower<Gold>("Midas Touch", " ", ModAPI.LoadSprite("gold.png"), "Acid");

            ModAPI.RegisterPower<Orbital>("Fire cannon", " ", ModAPI.LoadSprite("cannon.png"), "Bullet Power");
            ModAPI.RegisterPower<SuperPush>("Super Push", " ", ModAPI.LoadSprite("Exp.png"), "Bullet Power");
            ModAPI.RegisterPower<Explo>("Explosion", " ", ModAPI.LoadSprite("Explos.png"), "Bullet Power");
            ModAPI.RegisterPower<FireWorks>("FireWorks", " ", ModAPI.LoadSprite("firework.png"), "Bullet Power");



            ModAPI.RegisterPower<UnFreeze>("UnFreeze", " ", ModAPI.LoadSprite("UnFreeze.png"), "Heal Power");
            ModAPI.RegisterPower<Freeze>("Freeze", " ", ModAPI.LoadSprite("Freeze.png"), "Acid");

            ModAPI.RegisterPower<Androidtransformation>("Transform human to Android", " ", ModAPI.LoadSprite("HumantoA.png"));
            ModAPI.RegisterPower<Humantransformation>("Transform Android to human", " ", ModAPI.LoadSprite("AtoHu.png"), "Transform human to Android");
           // ModAPI.RegisterPower<AndroidBoneHeal>("Android Bone Heal", " ", ModAPI.LoadSprite("ABoneheal.png"), "Transform human to Android");
           // ModAPI.RegisterPower<AndroidHealPower>("Android Heal", " ", ModAPI.LoadSprite("Aheal.png"), "Transform human to Android");
            //ModAPI.RegisterPower<AndroidHeadExp>("Head Explosion", " ", ModAPI.LoadSprite("HeadExpAn.png"), "Transform human to Android");
           // ModAPI.RegisterPower<AndroidCrush>("Android Crush power", " ", ModAPI.LoadSprite("Aheadexp.png"), "Transform human to Android");

            ModAPI.RegisterPower<TimeX2>("Time Acceleration power (x2)", " ", ModAPI.LoadSprite("x2.png"));
            ModAPI.RegisterPower<TimeX4>("Time Acceleration power (x4)", " ", ModAPI.LoadSprite("x4.png"), "Time Acceleration power (x2)");
            ModAPI.RegisterPower<TimeX8>("Time Acceleration power (x8)", " ", ModAPI.LoadSprite("x4.png"), "Time Acceleration power (x2)");
            //ModAPI.RegisterPower<MadeInHeaven>("Made In Heaven", "Upon activation, time will gradually flow faster and faster in the whole universe. Can't be stopped ", ModAPI.LoadSprite("Madein.png"), "Time Acceleration power (x2)");
            ModAPI.RegisterPower<TimeStopPower>("Time Stop", " ", ModAPI.LoadSprite("Timestop.png"), "Time Acceleration power (x2)");
            ModAPI.RegisterPower<ColdPower>("Cryokinesis", " ", ModAPI.LoadSprite("ColdPower.png"), "Pyrokinesis");
            ModAPI.RegisterPower<BulletPower>("Bullet Power", "", ModAPI.LoadSprite("Bullet.png"), "");
           // ModAPI.RegisterPower<SunRayPower>("Sun Ray", " ", ModAPI.LoadSprite("ColdPower.png"), "Pyrokinesis");
            
        }
    }

    class BulletPower : ToolBehaviour
    {

        public float MouseMoveInfluence = 45f;
   
        private BallisticsEmitter ballisticsEmitter;
        Cartridge customCartridge = ModAPI.FindCartridge("9mm");
        private void Awake()
        {
            this.layers = LayerMask.GetMask(new string[]
            {
            "Debris",
            "Objects",
            "CollidingDebris"
            });

            this.ballisticsEmitter = new BallisticsEmitter(this, customCartridge)
            {
                MaxRange = 5f,
                TracerWidth = 0.1f,
                DoTraversal = true
            };


        }
  
        // Token: 0x06000C75 RID: 3189 RVA: 0x00040F4C File Offset: 0x0003F14C
        private void FixedUpdate()
        {
            this.mouseMovement = this.MouseMoveInfluence * (Global.main.MousePosition - oldMousePos);
            this.oldMousePos = Global.main.MousePosition;
            Debug.DrawLine(Global.main.MousePosition, Global.main.MousePosition + mouseMovement, Color.red);
        }

        // Token: 0x06000C76 RID: 3190 RVA: 0x00040FCC File Offset: 0x0003F1CC


        // Token: 0x06000C77 RID: 3191 RVA: 0x00040FF0 File Offset: 0x0003F1F0
        public override void OnFixedHold()
        {
            if (DialogBox.IsAnyDialogboxOpen || Global.ActiveUiBlock || Global.main.UILock || TriggerEditorBehaviour.IsBeingEdited)
            {
                return;
            }
          
            this.ballisticsEmitter.Emit(this.oldMousePos, this.mouseMovement.normalized);
        }

        protected virtual float GetFalloff(float intensity, float sqrDistance, float max)
        {
            return Mathf.Min(max, 4f * intensity / sqrDistance + this.mouseMovement.sqrMagnitude * 0.05f);
        }

        protected virtual GameObject CreateEffectObject()
        {
            return null;
        }


        public override void OnSelect()
        {

        }

    
        public override void OnDeselect()
        {

        }


        public override void OnHold()
        {
        }

        public override void OnToolChosen()
        {
        }

        public override void OnToolUnchosen()
        {
        }

        protected Collider2D[] buffer = new Collider2D[256];

        protected LayerMask layers;

        protected Vector3 mouseMovement;


        protected Vector3 oldMousePos;


    }

    class SunRayPower : ToolBehaviour
    {

        public float MouseMoveInfluence = 45f;
        LineRenderer line;

        private LayerMask bounds;

        RaycastHit2D ray;



        private void Awake()
        {
            this.layers = LayerMask.GetMask(new string[]
            {
            "Debris",
            "Objects",
            "CollidingDebris"
            });

            bounds = LayerMask.GetMask("Bounds");

            line = gameObject.AddComponent<LineRenderer>();
            line.material = ModAPI.FindMaterial("VeryBright");
            line.numCapVertices = 2;
            line.startColor = new Color(1.1f, 0f, 0f, 0.25f);
            line.endColor = new Color(1.1f, 0f, 0f, 0.25f);
            line.startWidth = 0.45f;
            line.endWidth = 0.45f;
            line.rendererPriority = 5;
        }


        public void Shoot()
        {
            line.startColor = new Color(0f, 0f, 1.1f, 0.25f);
            line.endColor = new Color(0f, 0f, 1.1f, 0.25f);
            line.startWidth = 0.10f;
            line.endWidth = 0.10f;

            if (ray.collider.gameObject.layer == 9)
            {
                ray.transform.GetComponent<PhysicalBehaviour>().Temperature = 5000f;

                float mass = 0f;
                for (int i = 0; i < ray.collider.transform.root.GetComponentsInChildren<Rigidbody2D>().Length; i++)
                {
                    mass += ray.collider.transform.root.GetComponentsInChildren<Rigidbody2D>()[i].mass;
                }

               // ray.collider.GetComponent<Rigidbody2D>().AddForceAtPosition((((BarrelPosition - ray.point).normalized * (3000f * mass)) * Time.deltaTime) * -0.02f, ray.point);
            }
        }




        // Token: 0x06000C75 RID: 3189 RVA: 0x00040F4C File Offset: 0x0003F14C
        private void FixedUpdate()
        {
            this.mouseMovement = this.MouseMoveInfluence * (Global.main.MousePosition - oldMousePos);
            this.oldMousePos = Global.main.MousePosition;
            Debug.DrawLine(Global.main.MousePosition, Global.main.MousePosition + mouseMovement, Color.red);
        }

        void Update()
        {
            ray = Physics2D.Raycast(oldMousePos, mouseMovement, Mathf.Infinity);
            line.SetPosition(0, oldMousePos);
            line.SetPosition(1, ray.point);
            line.startWidth = Mathf.MoveTowards(line.startWidth, 0f, Time.deltaTime);
            line.endWidth = Mathf.MoveTowards(line.endWidth, 0f, Time.deltaTime);

        }









        // Token: 0x06000C76 RID: 3190 RVA: 0x00040FCC File Offset: 0x0003F1CC


        // Token: 0x06000C77 RID: 3191 RVA: 0x00040FF0 File Offset: 0x0003F1F0
        public override void OnFixedHold()
        {
            if (DialogBox.IsAnyDialogboxOpen || Global.ActiveUiBlock || Global.main.UILock || TriggerEditorBehaviour.IsBeingEdited)
            {
                return;
            }
            Shoot();
            //  this.ballisticsEmitter.Emit(this.oldMousePos, this.mouseMovement.normalized);
        }

        protected virtual float GetFalloff(float intensity, float sqrDistance, float max)
        {
            return Mathf.Min(max, 4f * intensity / sqrDistance + this.mouseMovement.sqrMagnitude * 0.05f);
        }

        protected virtual GameObject CreateEffectObject()
        {
            return null;
        }


        public override void OnSelect()
        {

        }


        public override void OnDeselect()
        {

        }


        public override void OnHold()
        {
        }

        public override void OnToolChosen()
        {
        }

        public override void OnToolUnchosen()
        {
        }

        protected Collider2D[] buffer = new Collider2D[256];

        protected LayerMask layers;

        protected Vector3 mouseMovement;


        protected Vector3 oldMousePos;


    }
}